/***************************************************************************
 *
 * This is a part of AntMon project
 *
 *            ant_subst.cpp
 *
 *  Tue Aug 22 14:33:28 2006
 *  Copyright  2006  Sergey Zhumatiy
 *  serg@parallel.ru
 ****************************************************************************/
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <string.h>
#include "ant_subst.hpp"

#define ANT_SUBST_BUF_SIZE 2048
#define ANT_SUBST_MAX_VARNAME 256

char subst_buffer[ANT_SUBST_BUF_SIZE];

/* Substitute variables values into given string. */
/* Always the same buffer is returned! */
const char *subst(const char *s, std::map<std::string, std::string> &vars){

  int slash;
  char *b=subst_buffer;
  const char *namep;
  char name[ANT_SUBST_MAX_VARNAME];
  const char *value;
  //char space;

  std::string str;

  slash=0;

  while(*s && b!=subst_buffer+ANT_SUBST_BUF_SIZE-1){

    // was there slash?
    if(slash){
      slash=0;
      if(*s=='n')
        *b='\n';
      else if(*s=='t')
        *b='\t';
      else if(*s=='r')
        *b='\r';
      else
        *b=*s;
    }
    else{

      // slash?
      if(*s=='\\'){
        slash=1;
        --b;      // will be incremented back
      }
      // variable?
      else if(*s=='$'){

        // remember variable name
        namep=++s;
        while(*s && *s!='$' && !isspace(*s))
          ++s;

        strncpy(name,namep,s-namep);
        name[s-namep]='\0';

        str=vars[name];
        value=str.c_str();

        // copy value
        strncpy(b,value,ANT_SUBST_BUF_SIZE-1-(b-subst_buffer));

        b+=str.length()-1;  // we'll increment b later...

        // eol?
        if(*s=='\0')
          return subst_buffer;

        if(*s!='$'){
          *(++b)=*s;
        }
      }
      else
        *b=*s;
    }
    ++s;
    ++b;
  }
  return subst_buffer;
}
